<?php
/***********************************************************
============================================================
    Carousel for Gallery - CMSimple plugin
============================================================
Version:    2.0.0  
Copyright:  © Jerry Jakobsfeld 2009-2011
Website:    cmsimpleplugins.jakobsfeld.dk
Released under Remove Link and Commercial License. Please read file license.txt included in distribution package. 
Visit cimsimpleplugins.jakobsfeld.dk to buy a licence.

Carousel for Gallery works on the file structure builded by the Gallery by Michael Svarrer
Note: It's not necessary to use Svarrers Gallery to run this plugin but it makes work much easier.
Otherwise you have to manualy create the same file structure as Svarrers gallery does and manualy crate thumbs. 

Tested with modyfied version of gallery by Holger Irmler: Svarrers Gallery with Lightbox:
Supported lightbox: Lightbox version 2.04 and prettyPhoto 
php ver. 5.2 
in IE9, Firefox and Chrome.

Unzip downloaded file and move carouselgl folder to plugin folder of your CMSimple website.
To activate insert #CMSimple $output.= carouselgl('/path_to_your_gallery_folder');# somewhere on your page.

Disclaimer : No warranties at all, use on your own risk !
Requirements : The uPlgin-Loader must be installed and working ! , client must have flash player 9.0 or higher


version 1.0   (february. 2009)
version 1.1 (marts 2009)
	Solved conflict between flash and dhtml menus.  
	Resolved cache problems in IE
version 1.2  (december 2009)
	added:	$plugin_cf['carouselgl']['flashvars_bgcolor']="#FFFFFF";
					$plugin_cf['carouselgl']['flashvars_wmode']="transparent";
	to management of plugins background color
version 1.3  (january 2009)
	fixed missing quote when lightbox_show_titles is sat to false
version 1.4  (marts 2010)
	optimized creation of xml file (xml file is only created when config.php is updated)
version 2.0.0
	added prettyPhoto image viewer
	released under commercial and remove link license	
	 
***********************************************************/
function carouselgl($path, $lightbox=null) {
	global $plugin_cf, $plugin, $pth, $hjs;  //$_SERVER, $plugin_tx, 
	$plugin = basename(dirname(__FILE__), "/");
	
	if ($lightbox!=null)
		$plugin_cf['carouselgl']['lightbox']=$lightbox;

	carouselgl_load_scripts();		
	$fpw=null;
	
	$path=rtrim($path,"/");
	$flashfile = $pth['folder']['plugins'] . $plugin."/data/carousel.swf";	
	$xmlfile=filectime($pth['folder']['plugins'].$plugin."/config/config.php").".xml";
	if (!file_exists($pth['folder']['plugins'].$plugin."/data/".$xmlfile) || stristr($plugin_cf['carouselgl']['refresh_flash_data'],"true")) {
		$xmlfile = $pth['folder']['plugins'].$plugin."/data/".$xmlfile;
		carouselgl_cleandir($pth['folder']['plugins'].$plugin."/data/","*.xml");
		$xmlc = carouselgl_create_slide_show_parms();
		$fpw = fopen($xmlfile, 'w+') or die("Can't open file");
		fwrite($fpw, $xmlc);
	}
	$o.='<div id="carouselgl_anchorsdiv">';
	$handle = @opendir($path) or die("Unable to open $path");
	$id=0;
	
	$imgs="[";
	$titles="[";
	$descriptions="[";
	while (false !== ($file = readdir($handle))) {
		$exts = split("[/\\.]", $file) ;
		$exts = $exts[count($exts)-1]; 
		if (strtolower($exts)=='jpg') {
		  $info=carouselgl_get_gallery_info($path,$file);
		  $infoitem = explode(";", $info);
		  if (!stristr($plugin_cf['carouselgl']['lightbox_file_names'],"true")) {
		  	if (stristr($infoitem[0],".jpg"))
		  	$infoitem[0]="";
		  }
			$o.='<a rel="'.$plugin_cf['carouselgl']['lightbox'];
			if ($plugin_cf['carouselgl']['lightbox_group']!="")
        $o.='['.$plugin_cf['carouselgl']['lightbox_group'].']';
   		$o.='"';
      if(stristr($plugin_cf['carouselgl']['lightbox_show_titles'],"true")) {
      	$o.=' title="'.trim($infoitem[0]);
      	if(stristr($plugin_cf['carouselgl']['prettyphoto_title_as_description'],"true")) {
      		$descriptions.="'<strong>".trim($infoitem[0])."</strong>";
      		$titles.="'',";
     		}
     		else {
	      	$titles.="'".trim($infoitem[0])."',";
	      	$descriptions.="'";
	      }
	      for ($i=0; $i<sizeof($infoitem); $i++) {
	      	if (trim($infoitem[$i])!="") {
	      		$o.=tag('br');
	      		$descriptions.=tag('br');
	      	}
	      	$o.=trim($infoitem[$i+1]);
					$descriptions.=trim($infoitem[$i+1]);
	      }	
	      $descriptions.="',";
	      $o.='"';
      }
      else {
      	$titles.="'',";
	      $descriptions.="'',";
     	}
			$o.=' href="'.$path.'/'.$file;
			$o.='" id="carousel_anchor'.++$id.'_id">';
			$img ='img src="';
			$img.=$path.'/'.$file;
			$imgs.="'".$path.'/'.$file."',";
			$img.='" alt="'.$file.'"';
			$o.=tag($img);
			$o.='</a>';
			if (stristr($plugin_cf['carouselgl']['show_titles_carousel'],"true"))
				$title='title="'.$infoitem[0].'" ';
			else
				$title='';
			
			if ($fpw!=null) {
				switch (strtolower($plugin_cf['carouselgl']['lightbox'])) {
					case 'prettyphoto':
						fwrite($fpw,'<photo '.$title.' href="javascript:carousel_cklik('.$id.')" target="_self">'.$path.'/thumb/tn_'.$file.'</photo>');
						break;
					case 'lightbox':
						fwrite($fpw,'<photo '.$title.' href="javascript:aclick(\'carousel_anchor'.$id.'_id\')" target="_self">'.$path.'/thumb/tn_'.$file.'</photo>');
						break;
					default:
						exit("Missing lightbox");
						break;
				}
			}
	  }
	}
	$imgs=substr($imgs,0,-1)."]";
	$titles=substr($titles,0,-1)."]";
	$descriptions=substr($descriptions,0,-1)."]";
	$o.='</div>';	
	if (stristr($plugin_cf['carouselgl']['lightbox'],'prettyphoto')  ) {
		$hjs.=carouselgl_prettyPhotoScript($imgs,$titles,$descriptions);
	}
	closedir($handle);
	//$xmlfile.='</slide_show>';
	fwrite($fpw,'</slide_show>');
	flush();
	fclose($fpw);

	$t.='<div id="carouselgl_cardiv">';
	$t.='<!-- IE (et. al) Object -->';
	$t.='<object class="carouselgl_movie" id="Carousel__ie" classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"
		codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0">';
//	$t.=tag('object class="carouselgl_movie" id="Carousel__ie" type="application/x-shockwave-flash" data="'.$flashfile.'"');
		$t.=tag('param name="movie" value="'.$flashfile.'"');
		$t.=tag('param name="flashvars" value="xmlfile='.$xmlfile.'"');
		$t.=tag('param name="quality" value="High"');
		$t.=tag('param name="wmode" value="'.$plugin_cf['carouselgl']['flashvars_wmode'].'"');
		$t.=tag('param name="bgcolor" value="'.$plugin_cf['carouselgl']['flashvars_bgcolor'].'"');
		//$t.=tag('param name="allowscriptaccess" value="always"');
			$t.='<!--[if !IE]>-->
			<!-- Firefox (et. al) Object -->';
			$t.='<object class="carouselgl_movie" id="Carousel__ff"	type="application/x-shockwave-flash"
				data="'.$flashfile.'">';
				$t.=tag('param name="movie" value="'.$flashfile.'"');
				$t.=tag('param name="flashvars" value="xmlfile='.$xmlfile.'"');
				$t.=tag('param name="quality" value="high"');
				$t.=tag('param name="bgcolor" value="'.$plugin_cf['carouselgl']['flashvars_bgcolor'].'"');
				$t.=tag('param name="pluginurl" value="http://www.macromedia.com/go/getflashplayer"');
					$t.='<!-- No plugin -->
					<p>This page require <a href="http://www.adobe.com/">Adobe Flash 9.0</a> (or higher) plug in.</p>
			</object>';
			$t.='<!--<![endif]-->';
	$t.='</object>
	</div>
	';
	$t.=$o;
	//DO NOT REMOVE. To hide by license at http://test.jakobsfeld.dk/?Carousel_for_Gallery
	$t.='<p class="carouselgl_credits">CMSimple plugin: Carousel for Gallery'.tag('br').'&copy; 2009-2011 <a href="http://cmsimpleplugins.jakobsfeld.dk">Jerry Jakobsfeld</a></p>';
	//DO NOT REMOVE. To hide by license at http://test.jakobsfeld.dk/?Carousel_for_Gallery
	return $t;

	
}

//*****************************************************
// load lightbox scripts
//*****************************************************
function carouselgl_load_scripts() {	
 global $hjs, $pth, $cf, $plugin, $plugin_cf;
	 
	switch (strtolower($plugin_cf['carouselgl']['lightbox'])) { // load scripts
		case 'prettyphoto':
			carouselgl_load_prettyPhoto_header();
		break;
		case 'lightbox':
			carouselgl_load_lightbox_header();
		break;
		default:
			exit("Missing lightbox");
		break;
	}
}	

function carouselgl_create_slide_show_parms()
{
	global $plugin_cf;
	
	$xmlc='
	<?xml version="1.0" encoding="utf-8"?>
	<!-- fhShow Carousel 1.7 configuration file. Please visit http://www.flshow.net/ -->
	<slide_show>
	<options>
		<debug>'.$plugin_cf['carouselgl']['debug'].'</debug>
		<background>'.$plugin_cf['carouselgl']['background'].'</background>
		<friction>'.$plugin_cf['carouselgl']['friction'].'</friction>
    <fullscreen>'.$plugin_cf['carouselgl']['fullscreen'].'</fullscreen>
    <margins>
      <top>'.$plugin_cf['carouselgl']['margins_top'].'</top>
      <left>'.$plugin_cf['carouselgl']['margins_left'].'</left>
      <bottom>'.$plugin_cf['carouselgl']['margins_bottom'].'</bottom>
      <right>'.$plugin_cf['carouselgl']['margins_right'].'</right>
      <horizontal_ratio>'.$plugin_cf['carouselgl']['margins_horizontal_ratio'].'%</horizontal_ratio>
      <vertical_ratio>'.$plugin_cf['carouselgl']['margins_vertical_ratio'].'%</vertical_ratio>
    </margins>
		<interaction>
			<rotation>'.$plugin_cf['carouselgl']['interaction_rotation'].'</rotation>				
			<speed>'.$plugin_cf['carouselgl']['interaction_speed'].'</speed>								
			<view_point>'.$plugin_cf['carouselgl']['interaction_view_point'].'</view_point>	
			<default_speed>'.$plugin_cf['carouselgl']['interaction_default_speed'].'</default_speed>
       <default_view_point>'.$plugin_cf['carouselgl']['interaction_default_view_point'].'%</default_view_point>  
      <reset_delay>'.$plugin_cf['carouselgl']['interaction_reset_delay'].'</reset_delay>                 				 
		</interaction>	
		<far_photos>
			<size>'.$plugin_cf['carouselgl']['far-photos_size'].'</size>													
			<amount>'.$plugin_cf['carouselgl']['far-photos_amount'].'</amount>										
			<blur>'.$plugin_cf['carouselgl']['far-photos_blur'].'</blur>		
      <blur_quality>'.$plugin_cf['carouselgl']['far-photos_blur_quality'].'</blur_quality>    
		</far_photos>
		<reflection>
			<amout>'.$plugin_cf['carouselgl']['reflection_amout'].'</amout>						
			<blur>'.$plugin_cf['carouselgl']['reflection_blur'].'</blur>							
			<distance>'.$plugin_cf['carouselgl']['reflection_distance'].'</distance>	
			<alpha>'.$plugin_cf['carouselgl']['reflection_alpha'].'</alpha>						
		</reflection>
		<titles>
    	<default_style>font-size: 10px; font-family: Verdana, _serif; color: #333333;</default_style>
    </titles>
	</options>'."\n";
	
	return $xmlc;
}

function carouselgl_get_gallery_info($path,$file){
	// no support for gallerys multilanguage comments.
	$t='no title';
	$filename=preg_replace("/.jpg/i",".txt",$path.'/'.$file);
	if(file_exists($filename)){
		$fp=fopen($filename,"r");
		$line = fgets( $fp, 4048 );
	} 	
	fclose($fp);
	return $line;
}

function carouselgl_cleandir($path,$match){
   $dirs = glob($path."*");
   $files = glob($path.$match);
   foreach($files as $file){
      if(is_file($file)){
         unlink($file);
       }
   }
   foreach($dirs as $dir){
      if(is_dir($dir)){
         $dir = basename($dir) . "/";
         cleandir($path.$dir,$match);
      }
   }
}

function carouselgl_load_lightbox_header()
{			
	global $hjs, $pth, $cf, $plugin, $plugin_cf;
	
	if (!preg_match('/prototype\.js/i', $hjs)) {
		$hjs.='<script src="'.$pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/libs/lightbox/js/prototype.js" type="text/javascript"></script>';
	}	
	if (!preg_match('/scriptaculous\.js/i', $hjs)) {
		$hjs.='<script src="'.$pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/libs/lightbox/js/scriptaculous.js?load=effects,builder" type="text/javascript"></script>';
	}
	if (!preg_match('/lightbox\.js/i', $hjs)) {
		$hjs.='<script src="'.$pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/libs/lightbox/js/lightbox.js" type="text/javascript"></script>';
		$hjs.=tag('link rel="stylesheet" href="'.$pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/libs/lightbox/css/lightbox.css" type="text/css" media="screen"');
	}
}

function carouselgl_load_prettyPhoto_header()
{		
	global $hjs, $pth, $cf, $plugin, $plugin_cf;
	
	include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
	include_jQuery();
	include_jQueryPlugin('prettyphoto', $pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/libs/prettyPhoto/js/jquery.prettyPhoto.js');
	$hjs.=tag('link rel="stylesheet" href="'.$pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/libs/prettyPhoto/css/prettyPhoto.css'.'" type="text/css"');
	$hjs.="<script type=\"text/javascript\" charset=\"utf-8\">
		(function($) {
	 		$(document).ready(function() {
	   		$(\"a[rel^='prettyPhoto']\").prettyPhoto({
	   	 		theme: '".$plugin_cf['carouselgl']['prettyphoto_theme']."', 
	   	 		animation_speed: '".$plugin_cf['carouselgl']['prettyphoto_animation_speed']."', 
					slideshow: ".$plugin_cf['carouselgl']['prettyphoto_slideshow'].", 
					autoplay_slideshow: ".$plugin_cf['carouselgl']['prettyphoto_autoplay_slideshow'].", 
					opacity: ".$plugin_cf['carouselgl']['prettyphoto_opacity'].", /* Value between 0 and 1 */
					hideflash: true,";
	if (!stristr($plugin_cf['carouselgl']['prettyphoto_social_tools'],"true")) {
		$hjs.="\n\rsocial_tools: false,";
	}				
	$hjs.="\n\rshow_title: ".$plugin_cf['carouselgl']['lightbox_show_titles'].",
					overlay_gallery: ".$plugin_cf['carouselgl']['prettyphoto_overlay_gallery']."					
	   	 	});
	 	 	});
	  })(jQuery);
	</script>";
	return;
} 

function carouselgl_prettyPhotoScript($imgs,$titles,$descriptions)	
{	
	$o="<script type=\"text/javascript\" charset=\"utf-8\">
	  function carousel_cklik(anchor_id) {
			//alert (anchor_id);   
	  	api_images = ".$imgs.";
			api_titles = ".$titles.";
			api_descriptions = ".$descriptions.";
			jQuery.prettyPhoto.open(api_images.slice(anchor_id-1).concat(api_images.slice(0,anchor_id-1)),
															api_titles.slice(anchor_id-1).concat(api_titles.slice(0,anchor_id-1)),
															api_descriptions.slice(anchor_id-1).concat(api_descriptions.slice(0,anchor_id-1)));
		}
	</script>";
	return $o;
}		
?>